aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorAndreas Gruenbacher <agruenba@redhat.com>2016-10-19 13:50:14 +0200
committerEryu Guan <eguan@redhat.com>2016-10-21 23:20:14 +0800
commitf1edd77ebc28f95d97184faa570137f79ef2941c (patch)
tree87bda9eebd8a134af97acc75a227f5be87ed044a
parentdc46bab289da191e21adf3009b44dbbb28f86e1a (diff)
downloadxfstests-dev-f1edd77ebc28f95d97184faa570137f79ef2941c.tar.gz
generic: Check linking O_TMPFILE into namespace with POSIX ACLs
When an O_TMPFILE file is linked into a directory with a POSIX default ACL, the file should inherit the default ACL and the umask needs to be ignored. [eguan introduced testdir var and added test to acl group] Signed-off-by: Andreas Gruenbacher <agruenba@redhat.com> Reviewed-by: Eryu Guan <eguan@redhat.com> Signed-off-by: Eryu Guan <eguan@redhat.com>
-rwxr-xr-xtests/generic/38972
-rw-r--r--tests/generic/389.out6
-rw-r--r--tests/generic/group1
3 files changed, 79 insertions, 0 deletions
diff --git a/tests/generic/389 b/tests/generic/389
new file mode 100755
index 0000000000..6d63eda1e2
--- /dev/null
+++ b/tests/generic/389
@@ -0,0 +1,72 @@
+#! /bin/bash
+# FS QA Test 389
+#
+# Test if O_TMPFILE files inherit POSIX Default ACLs when they are linked into
+# the namespace.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016 Red Hat, Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/attr
+. ./common/filter
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+
+_require_test
+_require_xfs_io_command "flink"
+_require_acls
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+testdir="${TEST_DIR}/d.$seq"
+testfile="${testdir}/tst-tmpfile-flink"
+
+umask 022
+rm -rf ${testdir}
+mkdir -p ${testdir}
+setfacl -d -m u::rwx,g::rwx,o::rx ${testdir}
+$XFS_IO_PROG -T -m 0666 \
+ -c "pwrite 0 4096" \
+ -c "pread 0 4096" \
+ -c "flink ${testfile}" \
+ ${testdir} | _filter_xfs_io
+stat -c '%a' ${testfile}
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/389.out b/tests/generic/389.out
new file mode 100644
index 0000000000..4d11ac7a13
--- /dev/null
+++ b/tests/generic/389.out
@@ -0,0 +1,6 @@
+QA output created by 389
+wrote 4096/4096 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+read 4096/4096 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+664
diff --git a/tests/generic/group b/tests/generic/group
index fc32cfd2a6..3029bb4884 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -391,3 +391,4 @@
386 auto quick quota
387 auto clone
388 auto log metadata
+389 auto quick acl